import secrets


def get_random_values(byte_size: int) -> bytes:
    """
    Generates a bytearray of byte_size random bytes.

    This function creates a bytearray of byte_size bytes filled with random values generated by the
    operating system's secure random number generator. The resulting bytearray can be used for various
    cryptographic or security-related applications where random data is required.

    Args:
        byte_size (int): Lenght of the byte array required

    Returns:
        bytes: A byte array of length byte_size.
    """
    return secrets.token_bytes(byte_size)
